# LMA main

import os, sys

moduleDirs=[]

class ModuleWrapper:
    def __init__(self, module):
        self.priority=100
        self.category=1
        self.module=module
    
    def getCategory(self):
        try:
            return self.module.getCategory()
        except Exception, e:
            print "category query failed"
            import traceback
            traceback.print_exc()
            return self.category
    
    def getPriority(self):
        try:
            return self.module.getPriority()
        except Exception, e:
            print "priority query failed"
            import traceback
            traceback.print_exc()
            return self.priority

    def getName(self):
        try:
            return self.module.getName()
        except Exception, e:
            print "name query failed"
            import traceback
            traceback.print_exc()
            return "Unknown"

    def runTest(self,report,attributes):
        try:
            self.module.runTest(report,attributes)
        except Exception, e:
            print "Test " + self.getName() + " failed"
            import traceback
            traceback.print_exc()

class Report:
    def __init__(self):
        self.hardwareReport=""
        self.systemConfigurationReport=""
        self.softwareReport=""
    
    def appendHardwareSection(self, title, contents):
        self.hardwareReport=self.hardwareReport+"<H2>"+title+"</H2><P>"+contents+"</P>"

    def appendSystemConfigurationSection(self, title, contents):
        self.systemConfigurationReport=self.systemConfigurationReport+"<H2>"+title+"</H2><P>"+contents+"</P>"

    def appendSoftwareSection(self, title, contents):
        self.softwareReport=self.softwareReport+"<H2>"+title+"</H2><P>"+contents+"</P>"

    def generateReportOutput(self):
        output="<HTML><HEAD><TITLE>Linux migration advisor report</TITLE></HEAD><BODY>"
        output=output+"<H1>Hardware</H1>" + self.hardwareReport
        output=output+"<H1>System Configuration</H1>" + self.systemConfigurationReport
        output=output+"<H1>Software</H1>" + self.softwareReport
        output=output+"</BODY></HTML>"
        outputfile=file("output.html","wb")
        outputfile.write(output)
        outputfile.close()

class Attributes:
    pass

for entry in os.listdir("modules"):
    if entry[-2]=="p" and entry[-1]=="y":
        print "found module: " + entry
        moduleDirs.append(entry[0:len(entry)-3])

modules=[]

sys.path.append("modules")
for entry in moduleDirs:
    exec("import " + entry)
    exec("modules.append(ModuleWrapper(" + entry + "))")
    
report=Report()
attributes=Attributes()

for i in range(3):
    for j in range(100):
        for module in modules:
            if module.getCategory()==i+1:
                if module.getPriority()==j+1:
                    print "running " + module.getName()
                    module.runTest(report,attributes)

report.generateReportOutput()

print "Done."

import webbrowser
webbrowser.open("output.html")
